#define F_CPU 16000000UL
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>

#define set_bit(value, bit) ( _SFR_BYTE(value) |= _BV(bit) )
#define clear_bit(value, bit) ( _SFR_BYTE(value) &= ~_BV(bit) )

volatile uint8_t state = 1;      // LED의 상태

ISR(INT0_vect) {
  state = !state;       // LED 상태 전환
}

void INT0_init(void) {
  EIMSK |= (1 << INT0);     // INT0 인터럽트 허용
  EICRA |= (1 << ISC01);      // 하강 에지에서 인터럽트 발생
  sei();              // 전역적으로 인터럽트 허용
}

int main(void) {
  INT0_init();        // INT0 인터럽트 설정
  clear_bit(DDRD, 1);     // 버튼 연결 핀을 입력으로 설정
  set_bit(PORTD, 1);      // 내장 풀업 저항 사용 설정

  set_bit(DDRE, 3);     // LED 연결 핀을 출력으로 설정

  while (1) {
    if (!state) set_bit(PORTE, 3);
    else clear_bit(PORTE, 3);
  }

  return 0;
}
