#define F_CPU 16000000L
#include <avr/io.h>
#include <util/delay.h>
#include "UART0.h"
#include "ADC.h"

#define set_bit(value, bit) ( _SFR_BYTE(value) |= _BV(bit) )
#define clear_bit(value, bit) ( _SFR_BYTE(value) &= ~_BV(bit) )

#define THRESHOLD 100      // 경험적 수치

int main(void) {
  UART0_init();
  ADC_init(2);        // ADC 채널 2번 초기화

  set_bit(DDRB, 7);     // LED 연결 핀을 출력으로 설정
  clear_bit(PORTB, 7);      // LED는 끝 상태로 시작

  int read;

  while (1) {
    read = read_ADC();      // 채널 2번 읽기

    UART0_print(read);      // ADC값 출력

    if (read >= THRESHOLD) {    // LED 켜기
      UART0_print("\t LED is on.\n");
      set_bit(PORTB, 7);
    }
    else {            // LED 끄기
      UART0_print("\t LED is OFF.\n");
      clear_bit(PORTB, 7);
    }

    _delay_ms(1000);
  }

  return 0;
}
