#define F_CPU 16000000UL
#include <avr/io.h>
#include <util/delay.h>
#include "UART0.h"      // 컴퓨터 연결
#include "UART1.h"      // 블루투스 모듈 연결

ISR(USART1_RX_vect) {
  UART0_write(UDR1);      // 시리얼 모니터로 출력
  UART1_write(UDR1);      // 블루투스 모듈로 출력
}

int main(void) {
  UART0_init();
  UART1_init();

  UCSR1B |= (1 << RXCIE1);    // UART1 수신 완료 인터럽트 활성화
  sei();              // 전역적으로 인터럽트 허용

  while (1) {
  }

  return 0;
}
